Subject: RE: [Sipping] I-D ACTION:draft-fujimoto-sipping-header-lang-00.tx t

From: Adam Roach <[email-masked]>
Date: Wed, 25 Sep 2002 18:55:31 -0500

> -----Original Message-----
> From: Shingo Fujimoto [mailto:[email-masked]]
>
>  From my investigation, RFC2231 meets most of our needs but 
> sacrifice the efficiency of UTF-8 encoding. Except us-ascii 
> characters letters, all of UTF-8 codes are 8 bit flagged. That means 
> most (or all!) must be escaped with MIME B-encoding or Q-encoding. 
> That against the requirement "3.2 Data Size" in my I-D.

You appear to be confused about the nature of SIP.

SIP is encoded using UTF-8. Period. If you are using UTF-8 data,
there is no encoding necessary. You just drop the values directly
into the headers.

/a
_______________________________________________
Sipping mailing list  https://www1.ietf.org/mailman/listinfo/sipping
This list is for NEW development of the application of SIP
Use [email-masked] for questions on current sip
Use [email-masked] for new developments of core SIP

---

From: Shingo Fujimoto <[email-masked]>
Date: Thu, 26 Sep 2002 10:09:01 +0900

Adam Roach wrote:
> into the headers

RFC2231 doesn't allow "not specifying encoding" from its syntax.
The syntax in very last line should be replaced with:

encoded-word := "=?" charset ["*" language] "?" encoding "?" 
encoded-text "?="

# I confirmed RFC authors that the syntex had the error.

See this paragraph in RFC2231:
>    charset := <registered character set name>
> 
>    language := <registered language tag [RFC-1766]>
> 
>    The ABNF given in RFC 2047 for encoded-words is:
> 
>    encoded-word := "=?" charset "?" encoding "?" encoded-text "?="
> 
>    This specification changes this ABNF to:
> 
>    encoded-word := "=?" charset ["*" language] "?" encoded-text "?="

The (corrected) syntax requires specifying one of the pre-defined 
'encoding's ("B" or "Q"). If we choose RFC2231 as the solution, we 
MUST escape UTF-8 multibyte characters, in "B" or "Q" encoding.
# See definition of B-encoding and Q-encoding in MIME RFC.

I also asked the RFC authors for the possibility to define new 
encoding for UTF-8, like "U" encoding. But they prefer not to 
extending MIME itself, but defining private extension for SIP. Since 
there are large number of mail gateways which is not 8bit safe, that 
is not desirable to add new loose encoding.

Then, I tried to shape up RFC2047 for "the nature of SIP".

1) no charset  - SIP always uses "UTF-8"
2) no encoding - SIP always uses "U-encoding"

U-encoding was never defined, but the escaping rule in my I-D is the 
equivalent.

-- 
======================================
          SHINGO FUJIMOTO
     FUJITSU LABORATORIES LIMITED
E-mail: [email-masked]